class FaceReg{
  PVector[] sommets;
  PVector[] sommetsAux;
  PVector normale;
  PVector centre;
  PVector[] rayons;
  PVector translation;
  float translationNum;
  int transparence;
  float echelle;
  color couleur;
  boolean visible;
  boolean etoile;
  float t, pourcent ;  //  pourcentage de trou;
  boolean partieDeLaFigure;
  
  public FaceReg(PVector[] sommets){
    this.sommets = sommets; //mieux de faire une copie
    this.sommetsAux = new PVector[sommets.length];
    // Copier sommets dans sommetsAux
    for(int i = 0; i < sommets.length; i++){
      sommetsAux[i] = new PVector(sommets[i].x, sommets[i].y, sommets[i].z);
    }
    calculNormale();
    calculCentre();
    calculRayons();
    translationNum = 0;
    translation = new PVector(0, 0, 0);
    transparence = 0;
    echelle = 1;
    couleur = color(0, 0, 0, transparence);
    visible = true;
    etoile = true;
    // Évidement de la face
    t = 0;
    partieDeLaFigure = true;
  }
  
  public void display(){
    ArrayList<PVector> sommetsPlus = new ArrayList();
    if(visible && partieDeLaFigure){
      PVector newCentre = PVector.add(centre, translation);
      PVector[] newRayons = new PVector[sommetsAux.length];
      for(int i = 0; i < sommetsAux.length; i++){
        newRayons[i] = PVector.mult(rayons[i], echelle);
      }
      PVector[] newSommets = new PVector[sommetsAux.length];
      for(int i = 0; i < sommetsAux.length; i++){
        newSommets[i] = PVector.add(newCentre, newRayons[i]);
      }
      
      beginShape();
        fill(couleur);
        noStroke();
        for(int i = 0; i < sommetsAux.length; i++){
          vertex(newSommets[i].x, newSommets[i].y, newSommets[i].z);
          if(etoile){
            PVector s, r;
            if(i < sommetsAux.length -1){
              r = PVector.add(newRayons[i], newRayons[i+1]);
            }else{
              r = PVector.add(newRayons[i], newRayons[0]);
            }
            r.mult(0.5 * pourcent);
            s = PVector.add(newCentre, r);
            sommetsPlus.add(s);
            vertex(s.x, s.y, s.z);
          }
        }
        
        if(t > 0){
          beginContour();
          noStroke();
          for(int i = 0; i < sommetsAux.length; i++){
            vertex(t*newSommets[i].x + (1-t)*newCentre.x, t*newSommets[i].y + (1-t)*newCentre.y, t*newSommets[i].z + (1-t)*newCentre.z);
            if(etoile){
              PVector s = sommetsPlus.get(i);
              vertex(t*s.x + (1-t)*newCentre.x, t*s.y + (1-t)*newCentre.y, t*s.z + (1-t)*newCentre.z);
            }
          }
          endContour();
        }
        
      endShape();
    }
  }
  
  void calculNormale(){
    float lg = 0;
    PVector max = new PVector(0, 0, 0);
    int l = sommetsAux.length;
    for(int i = 0; i < l; i++){
      PVector u, v, o, n;
      // calculer u et v
      int j = (i+1) % l;
      int k = (i+2) % l;
      u = sommetsAux[i].get();
      o = sommetsAux[j].get();
      v = sommetsAux[k].get();
      u.sub(o);
      v.sub(o);
      n = u.cross(v);
      if (n.mag() > max.mag()){max = n.get();}
    }
    normale = max.get();
    normale.normalize();
    //println(normale);
  }
  
  void calculCentreGeometrique(){
    PVector u, v, o;
    u = sommetsAux[0].get();
    o = sommetsAux[1].get();
    v = sommetsAux[2].get();
    u.sub(o);
    v.sub(o);
    float a, b, c, x, y;
    a = u.dot(u);
    b = v.dot(v);
    c = u.dot(v);
    x = (a*b-b*c)/(2*(a*b-c*c));
    y = (a*c-b*a)/(2*(c*c-a*b));
    PVector q = PVector.add(PVector.mult(u, x), PVector.mult(v, y));
    centre = PVector.add(q, o);
  }
  
  void calculCentre(){ // Barycentre
  float totalX = 0, totalY = 0, totalZ = 0;
  int l = sommetsAux.length;
    for(int i = 0; i < l; i++){
      PVector u = sommetsAux[i].get();
      totalX += u.x;
      totalY += u.y;
      totalZ += u.z;
    }
    centre = new PVector(totalX/l, totalY/l, totalZ/l);
  }
  
  void calculRayons(){
    rayons = new PVector[sommetsAux.length];
    for(int i = 0; i < sommetsAux.length; i++){
      PVector u = sommetsAux[i].get();
      u.sub(centre);
      rayons[i] = u;
    }
  }
  
  void setTransparence(int t){
    transparence = t;
    couleur = color(red(couleur), green(couleur), blue(couleur), t);
  }
 /* 
  void setTranslation(PVector t){
    translation = new PVector(t.x, t.y, t.z); // crée le vecteur de translation
  }
*/ 
 void setTranslationN(float t){
   translationNum = t;
   translation = PVector.mult(normale, t);
 }
 
 float translationN(){
   return translationNum;
 }
 /*
 void setTranslationN(PVector p){
   float x = p.dot(normale);
   setTranslationN(x);
 }
 */
  
  void setEchelle(float e){
    echelle = e;
  }
  
  void setCouleur(color c){
    couleur = c;
  }
  
  void setVisible(boolean b){
    visible = b;
  }
  
  boolean getVisible(){
    return visible;
  }
  
  void setPourCentTrou(float u){
    t = min(max(0, u), 1);
  }
  
  void init(){
    translation = new PVector(0, 0, 0);
    translationNum = 0;
    transparence = 0;
    echelle = 1;
    couleur = color(0, 0, 0, transparence);
    visible = true;
    t = 0;
    etoile = false;
    pourcent = 0.5;
    for(int i = 0; i < sommets.length; i++){
      sommetsAux[i] = new PVector(sommets[i].x, sommets[i].y, sommets[i].z);
    }
    calculNormale();
    calculCentre();
    calculRayons();
  }
  
  void modifierSommet(int i, PVector v){
    PVector u = sommetsAux[i];
    if((u.x == v.x) && (u.y == v.y) && (u.z == v.z)){return;}
    sommetsAux[i] = v;
    calculNormale();
    calculCentre();
    calculRayons();
  }
  
}
